#!/usr/bin/env python
#
# Copyright 2009 Marcelo Boveto Shima.
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.    See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA    02110-1301, USA.
#
# Author: marceloshima@gmail.com (Marcelo Boveto Shima)


import dbus.mainloop.glib
dbus.mainloop.glib.DBusGMainLoop(set_as_default=True)

import dbus
import gobject
import os
import subprocess

from tacix.util import *

def receive_signal(state):
    print(state)
    if state == 'terminated':
        mainloop.quit()
    if state == 'ready':
        txsession.Run()
    if state == 'waiting_connection':
        provider = dbus.Interface(bus.get_object('org.tacix.nx', '/org/tacix/nx/provider'), 'org.tacix.nx.provider')
        session_id = txsession.GetProperty('id')
        print(session_id)
        proxy_options = provider.GetNXProxyOptions(session_id)
        print('%r' % proxy_options)
        file_path = '/home/%s/.nx/%s.script' % (os.environ['NX_USER'], session_id)
        open(file_path, 'w').write('#/bin/sh\n' + proxy_options['script'])
        os.chmod(file_path, 0700)
        subprocess.Popen(file_path, shell=True)

mainloop = gobject.MainLoop()
bus = dbus.SystemBus()
manager_obj = bus.get_object (BUS_NAME, MANAGER_PATH)
manager = dbus.Interface (manager_obj, MANAGER_INTERFACE)

session_path = manager.CreateSession (os.environ['NX_USER'], 'nx')
session_obj = bus.get_object (BUS_NAME, session_path)
txsession = dbus.Interface (session_obj, SESSION_INTERFACE)

state_signal = txsession.connect_to_signal("StateChanged", receive_signal, dbus_interface=SESSION_INTERFACE)

mainloop.run()
